/// <reference types="codemirror" />
export interface UseCodeMirrorOptions {
    autoCursor?: boolean;
    autoScroll?: boolean;
    cursor?: CodeMirror.Position;
    doc?: CodeMirror.Doc;
    docName?: string;
    scroll?: SetScrollOptions;
    selection?: {
        ranges: Array<SetSelectionOptions>;
        focus?: boolean;
    };
    value: string;
    config?: CodeMirror.EditorConfiguration;
    onBlur?: () => void;
    onChange?: (value: string, docName: string | undefined, changes: CodeMirror.EditorChange[], doc: CodeMirror.Doc) => void;
    onCursor?: (data: CodeMirror.Position) => void;
    onFocus?: () => void;
    onGutterClick?: (lineNumber: number, gutter: string, event: Event) => void;
    onScroll?: (scrollInfo: CodeMirror.ScrollInfo) => void;
    onSelection?: (data: any) => void;
    onViewportChange?: (start: number, end: number) => void;
    importCodeMirror?: () => Promise<any>;
    importCodeMirrorAddons?: () => Promise<any>;
}
export interface SetScrollOptions {
    x?: number | null;
    y?: number | null;
}
export interface SetSelectionOptions {
    anchor: CodeMirror.Position;
    head: CodeMirror.Position;
}
export declare type CodeMirrorRefFunction = {
    bivarianceHack(instance: HTMLElement | null): void;
}['bivarianceHack'];
export interface ReactCodeMirror {
    config: CodeMirror.EditorConfiguration;
    editor?: CodeMirror.Editor;
    focus(): void;
    ref: CodeMirrorRefFunction;
}
export declare function useCodeMirror(unmemoizedOptions: UseCodeMirrorOptions): ReactCodeMirror;
export interface CodeMirrorConstructor {
    new (callback: (host: HTMLElement) => void, options?: CodeMirror.EditorConfiguration): CodeMirror.Editor;
    Doc: any;
    defaults: any;
}
